function [avE, order, score]=Calc_Energy(X,basis,K,av_norm) 

% Ann Lee, April 2007

[Nvecs,p]=size(basis);
[n,p2]=size(X);  % X(n,p), basis(Nvecs,p)

coeffs = X*basis';  % coeffs(n,Nvecs); each row is an observation
energy = coeffs.*coeffs; % energy(n,Nvecs)  % not normalized!

avE = mean(energy,1);  % average over the sample first; avE(1,Nvecs)
if nargin<4
    av_norm = mean(sum(X.*X,2));
end
avE=avE/av_norm;  % normalize!

% energy in top K basis vectors
[avE,order]=sort(avE);   avE=fliplr(avE); order=fliplr(order);
%plot(avE),
if nargout>2
    score = sum(avE(1:K));
end